VERSION 5.00
Begin VB.Form SampleForm 
   Caption         =   "Sample Client Application for "
   ClientHeight    =   5790
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6825
   Icon            =   "vb6sample.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   5790
   ScaleWidth      =   6825
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton Command_Close 
      Caption         =   "Close"
      Height          =   345
      Left            =   5280
      TabIndex        =   5
      Top             =   5340
      Width           =   1425
   End
   Begin VB.CommandButton Command_PrinterPreferences 
      Caption         =   "Printer Preferences"
      Height          =   345
      Left            =   120
      TabIndex        =   4
      Top             =   5340
      Width           =   1800
   End
   Begin VB.Frame Frame1 
      Height          =   150
      Left            =   105
      TabIndex        =   3
      Top             =   5085
      Width           =   6615
   End
   Begin VB.ListBox ListBox1 
      Height          =   3960
      Left            =   90
      TabIndex        =   0
      Top             =   825
      Width           =   6615
   End
   Begin VB.Label Label2 
      Caption         =   "* Double click on the line containing file path to open the file with the default application."
      Height          =   270
      Left            =   90
      TabIndex        =   2
      Top             =   4875
      Width           =   6660
   End
   Begin VB.Label Label1 
      Caption         =   $"vb6sample.frx":08CA
      Height          =   600
      Left            =   105
      TabIndex        =   1
      Top             =   90
      Width           =   6615
   End
End
Attribute VB_Name = "SampleForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' A sample form demonstrating the virtual printer integration methods
' and print job information retrieval.

Option Explicit

Public Enum TransferModes
    ThroughCommandLine = 0
    ThroughCopydata = 1
End Enum

Const sPrinterName As String = "Your Virtual Printer Example"
Const sRegistryKey As String = "Your Virtual Printer Example"

Const sMsgBoxCaption As String = sPrinterName & " (VB.NET)"

' GDI constants
Const WM_COPYDATA As Long = &H4A
Const DC_PAPERS As Long = 2
Const DC_PAPERNAMES As Long = 16
Const DC_PAPERSIZE As Long = 3

' General virtual printer settings
Public lTransferMode As Long
Public lMessageID As Long
Public sInputIniFilePath As String


Private Sub Form_Load()

    ' Change form caption
    Caption = "Sample Client Application for " & sPrinterName
    
    ' Get general settings
    lTransferMode = GetRegDWord(HKEY_LOCAL_MACHINE, "Software\" & sRegistryKey, "Transfer Mode", ThroughCommandLine)
    lMessageID = GetRegDWord(HKEY_LOCAL_MACHINE, "Software\" & sRegistryKey, "Message ID", -1)
    
    
    If lTransferMode = ThroughCommandLine Then
        ' get path if print job information file from the command line
        sInputIniFilePath = Command()
        
        Dim FSO As New FileSystemObject
        
        ' check the file exists
        If FSO.FileExists(sInputIniFilePath) = False Then
            ListBox1.AddItem ("Invalid command line parameter!")
        ' fill the listbox with print job information
        Else: FillInfo
        End If
   
    Else: ListBox1.AddItem ("Waiting for a print job...")
    End If
    
    ' subclass the window for message processing
    StartSubclass Me.hwnd

End Sub

Public Sub FillInfo()

    Dim sDestination As String * 256
    Dim sTemp As String
    Dim iCount, i As Integer
    Dim iHorizontalResolution, iVerticalResoultion As Integer
    Dim iOrientation, iCopies, iCollate As Integer
    Dim iFormWidth, iFormHeight As Integer
        
    ListBox1.Clear
    
    ' show the transfer mode:
    ListBox1.AddItem ("Transfer mode = " & Switch( _
        lTransferMode = TransferModes.ThroughCommandLine, "Through the command line", _
        lTransferMode = TransferModes.ThroughCopydata, "Through the WM_COPYDATA message"))
    ListBox1.AddItem ("")
    
    ' show the input INI file path
    ListBox1.AddItem (sInputIniFilePath)
    ListBox1.AddItem ("")
    
    ' show device name:
    GetPrivateProfileString "Device", "DeviceName", "", sDestination, Len(sDestination), sInputIniFilePath
    'sDestination = Left(sDestination, InStr(sDestination, Chr(0)) - 1)
    Trim (sDestination)
    ListBox1.AddItem ("Device name = " & sDestination)
    
    ' show print job (document) name:
    GetPrivateProfileString "Document", "Name", "", sDestination, Len(sDestination), sInputIniFilePath
    Trim (sDestination)
    ListBox1.AddItem ("Device name = " & sDestination)
    
    ' show document resolution (dpi):
    iHorizontalResolution = GetPrivateProfileInt("Document", "HorizontalResolution", 0, sInputIniFilePath)
    ListBox1.AddItem ("Horizontal Resolution = " & iHorizontalResolution & "dpi")
    iVerticalResoultion = GetPrivateProfileInt("Document", "VerticalResolution", 0, sInputIniFilePath)
    ListBox1.AddItem ("Vertical Resolution = " & iVerticalResoultion & "dpi")
    
    ' show page orientation (1 - portrait, 2 - landscape):
    iOrientation = GetPrivateProfileInt("Document", "Orientation", 0, sInputIniFilePath)
    sTemp = Switch(iOrientation = 1, "Portrait", iOrientation = 2, "Landscape", True, "?")
    ListBox1.AddItem ("Orientation = " & sTemp)
    
    ' show name and size of the paper form:
    GetPrivateProfileString "Document", "PaperSizeName", "", sDestination, Len(sDestination), sInputIniFilePath
    Trim (sDestination)
    iFormWidth = Win32.GetPrivateProfileInt("Document", "PaperWidth", 0, sInputIniFilePath)
    iFormHeight = Win32.GetPrivateProfileInt("Document", "PaperLength", 0, sInputIniFilePath)
    ListBox1.AddItem ("Paper Size = " & sDestination & " (" & iFormWidth / 10 & "mm x " & iFormHeight / 10 & "mm)")
    
    ' show printer bin:
    GetPrivateProfileString "Document", "BinName", "", sDestination, Len(sDestination), sInputIniFilePath
    Trim (sDestination)
    ListBox1.AddItem ("Paper Bin = " & sDestination)

    ' show print job (document) page count:
    iCount = GetPrivateProfileInt("Document", "Pages", 0, sInputIniFilePath)
    ListBox1.AddItem ("Document Pages = " & iCount)
    
    ' show print job (document) copies count:
    iCopies = GetPrivateProfileInt("Document", "Copies", 0, sInputIniFilePath)
    ListBox1.AddItem ("Copies = " & iCopies)
    
    ' show print job (document) collate option:
    iCollate = GetPrivateProfileInt("Document", "Collate", 0, sInputIniFilePath)
    sTemp = Switch(iCollate = 0, "No", True, "Yes")
    ListBox1.AddItem ("Collate = " & sTemp)
    ListBox1.AddItem ("")
    
    ' show paths of generated images files:
    
    Dim sFormat As Variant
    Dim Formats(8) As String
    Formats(0) = "EMF": Formats(1) = "BMP": Formats(2) = "PNG": Formats(3) = "JPEG": Formats(4) = "TIFF"
    Formats(5) = "PDF": Formats(6) = "TXT": Formats(7) = "SWF"
       
    For Each sFormat In Formats
        iCount = GetPrivateProfileInt(sFormat, "Count", 0, sInputIniFilePath)
        ListBox1.AddItem (sFormat & " files (" & iCount & "):")
        
        For i = 0 To iCount - 1
            GetPrivateProfileString sFormat, "File" & i, "", sDestination, Len(sDestination), sInputIniFilePath
            Trim (sDestination)
            ListBox1.AddItem (sDestination)
        Next i
        
        ListBox1.AddItem ("")
        
    Next sFormat
    
End Sub

Private Sub Form_Unload(Cancel As Integer)

    ' unsubclass the window
    StopSubclass Me.hwnd

End Sub

Private Sub Command_PrinterPreferences_Click()

    ' run the Printer Properties module
    ShellExecute 0, "open", "properties.exe", "", App.Path, SW_SHOW

End Sub

Private Sub Command_Close_Click()

    ' exit the application
    Unload Me
    
End Sub

Private Sub ListBox1_DblClick()

    ' if listbox item contains file path it will be opened with default associated application
    ShellExecute 0, "open", ListBox1.List(ListBox1.ListIndex), "", "", SW_SHOW

End Sub
